Solo Game Dev – What Tools to Use to Share Your Work
======

![gamedev-logo](screenshots/gamedev-logo-3.png)

What tools and techniques do you use to record and share your work? Along with any tips, tutorials, costs, downloads, or social media concerns you might deal with? (Using only free tools)

When developing video games or any visual application, we often find ourselves needing skills or tools that we didn’t first consider. And because it can be so easy to get wrapped up in what WE can see (our code, our assets, our game design), we’ll often ignore what others can see, (footage, screen captures, gifs). Which can be quite harmful if you’re trying to drum up support for your latest project. Because saying that you’re working on a game is good, but showing that you are is always better.

## Content

*   [GadwinPrintScreen](https://www.gadwin.com/printscreen/) for screenshot with cursor
*   [ScreenToGif](http://www.screentogif.com/) for animated GIF
*   [FlashIntegro](http://www.videosoftdev.com/) for video (short or edited)
*   [LibreOffice](https://www.libreoffice.org/)-Presentation for marketing stuff
*   ….then [Buffer](https://buffer.com/) to schedule and share all this content on Twitter, Facebokk & Instagram, with tags like #MobileGame #IndieGame #GameDev #Puzzle #Game #Screenshot #Android #GooglePlay

![resulat.gif](screenshots/resulat1.gif)

* * *

## [GadwinPrintScreen](https://www.gadwin.com/printscreen/) for screenshot with cursor

Download it at [https://www.gadwin.com/printscreen/](https://www.gadwin.com/printscreen/)

You need to configure it with :

*   Preferences > Show widget : off
*   Image > Capture Mouse cursor: on, Cursor file : on
*   Post capture actions > Save Capture to file : on, Copy to clipboard

Then use it zone-capture mode with :

1.  press Ctrl+Impr
2.  select capture-zone
3.  press Enter to confirm selection
4.  …repeat or get your file in User/Pictures/MyScreenshots

![Screen Shot 05-27-18 at 06.39 PM 001](screenshots/screen-shot-05-27-18-at-06-39-pm-001.png)

![Screen Shot 05-27-18 at 06.39 PM 002](screenshots/screen-shot-05-27-18-at-06-39-pm-002.png)

![Screen Shot 05-27-18 at 06.40 PM](screenshots/screen-shot-05-27-18-at-06-40-pm.png)

![Screen Shot 05-27-18 at 06.40 PM 001.PNG](screenshots/screen-shot-05-27-18-at-06-40-pm-001.png)

* * *

## [ScreenToGif](http://www.screentogif.com/) for animated GIF

You need to use it zone-capture mode by :

1.  download it at [http://www.screentogif.com/](http://www.screentogif.com/)
2.  start ScreenToGif app
    1.  click Record > select zone > click record or F7
    2.  …do your demo
    3.  click stop or F8
3.  …wait for editor to start
    1.  Image > Resize > select a smaller resolution height like ‘720p or 480p’ -> Apply
    2.  select non-relevant beginning frames > click Supprt > confirm
    3.  select non-relevant ending frames > click Supprt > confirm
    4.  test it with Playback > Play
    5.  File > Save as > Save

![Screen Shot 05-27-18 at 07.39 PM](screenshots/screen-shot-05-27-18-at-07-39-pm.png)![Screen Shot 05-27-18 at 07.41 PM](screenshots/screen-shot-05-27-18-at-07-41-pm.png)![Screen Shot 05-27-18 at 07.43 PM](screenshots/screen-shot-05-27-18-at-07-43-pm.png)![Screen Shot 05-27-18 at 07.44 PM](screenshots/screen-shot-05-27-18-at-07-44-pm.png)

![Screen Shot 05-27-18 at 07.47 PM](screenshots/screen-shot-05-27-18-at-07-47-pm.png)

![Screen Shot 05-27-18 at 07.48 PM](screenshots/screen-shot-05-27-18-at-07-48-pm.png)

![Screen Shot 05-27-18 at 07.48 PM 001](screenshots/screen-shot-05-27-18-at-07-48-pm-001.png)

![Screen Shot 05-27-18 at 07.48 PM 002](screenshots/screen-shot-05-27-18-at-07-48-pm-002.png)![Screen Shot 05-27-18 at 07.48 PM 003](screenshots/screen-shot-05-27-18-at-07-48-pm-003.png)

![resulat.gif](screenshots/resulat.gif)

* * *

## [FlashIntegro](http://www.videosoftdev.com/) for video (short or edited)

You need to use it zone-capture mode, editing mode, then compression :

1.  download it at [http://www.videosoftdev.com/](http://www.videosoftdev.com/)
2.  start VSDC Screen Recorder
    1.  click Start
    2.  select capture zone > click record button or F5
    3.  …do your demo
    4.  click stop or Maj+F5
    5.  quit app
3.  start VSDC Video Editor
    1.  import video
    2.  delete before part
        1.  move cursor to the real video start (after trash frames)
        2.  click split
        3.  delete start chunk
    3.  delete end part
        1.  move cursor to the real video end (before trash frames)
        2.  click split
        3.  delete end chunk
    4.  move middle chunk to timeline start
    5.  preview the final result
    6.  export menu
        1.  click youtube
        2.  click export
        3.  click continue on popup
        4.  …wait for it
        5.  get file from User/Videos folder

![Screen Shot 05-27-18 at 07.55 PM](screenshots/screen-shot-05-27-18-at-07-55-pm1.png)

![Screen Shot 05-27-18 at 07.56 PM](screenshots/screen-shot-05-27-18-at-07-56-pm1.png)![Screen Shot 05-27-18 at 07.56 PM 001](screenshots/screen-shot-05-27-18-at-07-56-pm-0011.png)![Screen Shot 05-27-18 at 07.56 PM 002](screenshots/screen-shot-05-27-18-at-07-56-pm-0021.png)

![Screen Shot 05-27-18 at 08.07 PM](screenshots/screen-shot-05-27-18-at-08-07-pm.png)

![Screen Shot 05-27-18 at 08.07 PM 001](screenshots/screen-shot-05-27-18-at-08-07-pm-001.png)

![Screen Shot 05-27-18 at 08.08 PM](screenshots/screen-shot-05-27-18-at-08-08-pm.png)

![Screen Shot 05-27-18 at 08.09 PM](screenshots/screen-shot-05-27-18-at-08-09-pm.png)![Screen Shot 05-27-18 at 08.10 PM](screenshots/screen-shot-05-27-18-at-08-10-pm.png)

![Screen Shot 05-27-18 at 08.10 PM 001](screenshots/screen-shot-05-27-18-at-08-10-pm-001.png)![Screen Shot 05-27-18 at 08.11 PM 001](screenshots/screen-shot-05-27-18-at-08-11-pm-001.png)![Screen Shot 05-27-18 at 08.11 PM 003](screenshots/screen-shot-05-27-18-at-08-11-pm-003.png)![Screen Shot 05-27-18 at 08.11 PM 004](screenshots/screen-shot-05-27-18-at-08-11-pm-004.png)![Screen Shot 05-27-18 at 08.11 PM 005](screenshots/screen-shot-05-27-18-at-08-11-pm-005.png)

![Screen Shot 05-27-18 at 08.11 PM 006.PNG](screenshots/screen-shot-05-27-18-at-08-11-pm-0061.png)

![Screen Shot 05-27-18 at 08.12 PM](screenshots/screen-shot-05-27-18-at-08-12-pm.png)

![Screen Shot 05-27-18 at 08.12 PM 002](screenshots/screen-shot-05-27-18-at-08-12-pm-002.png)![Screen Shot 05-27-18 at 08.12 PM 003](screenshots/screen-shot-05-27-18-at-08-12-pm-003.png)![Screen Shot 05-27-18 at 08.12 PM 004](screenshots/screen-shot-05-27-18-at-08-12-pm-004.png)![Screen Shot 05-27-18 at 08.12 PM 005](screenshots/screen-shot-05-27-18-at-08-12-pm-005.png)![Screen Shot 05-27-18 at 08.15 PM](screenshots/screen-shot-05-27-18-at-08-15-pm.png)![Screen Shot 05-27-18 at 08.16 PM 001](screenshots/screen-shot-05-27-18-at-08-16-pm-001.png)

![result2.gif](screenshots/result2.gif)

## [LibreOffice](https://www.libreoffice.org/)-Presentation for marketing stuff

You must install LibreOffice, then make a simple presentation:

1.  start Libre Office Impress
2.  create presentation > empty template
3.  Insert > Images
    1.  select in explorer
    2.  resize it
4.  select image group
    1.  Aligne > horizontaly spacing
    2.  Align > top
5.  Insert text with bold, size
6.  Edit background color
7.  Export to *.png without transparency

![Screen Shot 05-27-18 at 09.15 PM 001](screenshots/screen-shot-05-27-18-at-09-15-pm-001.png)![Screen Shot 05-27-18 at 09.15 PM 002](screenshots/screen-shot-05-27-18-at-09-15-pm-002.png)

![Screen Shot 05-27-18 at 08.49 PM](screenshots/screen-shot-05-27-18-at-08-49-pm.png)![Screen Shot 05-27-18 at 08.50 PM](screenshots/screen-shot-05-27-18-at-08-50-pm.png)

![Screen Shot 05-27-18 at 08.53 PM](screenshots/screen-shot-05-27-18-at-08-53-pm.png)![Screen Shot 05-27-18 at 08.53 PM 001](screenshots/screen-shot-05-27-18-at-08-53-pm-001.png)

![Screen Shot 05-27-18 at 08.53 PM 002](screenshots/screen-shot-05-27-18-at-08-53-pm-002.png)

![Screen Shot 05-27-18 at 08.55 PM](screenshots/screen-shot-05-27-18-at-08-55-pm.png)![Screen Shot 05-27-18 at 08.57 PM](screenshots/screen-shot-05-27-18-at-08-57-pm.png)![Screen Shot 05-27-18 at 08.58 PM](screenshots/screen-shot-05-27-18-at-08-58-pm.png)![Screen Shot 05-27-18 at 08.59 PM 001](screenshots/screen-shot-05-27-18-at-08-59-pm-001.png)![Screen Shot 05-27-18 at 09.01 PM 001](screenshots/screen-shot-05-27-18-at-09-01-pm-001.png)![Screen Shot 05-27-18 at 09.01 PM](screenshots/screen-shot-05-27-18-at-09-01-pm.png)![Screen Shot 05-27-18 at 09.02 PM 001](screenshots/screen-shot-05-27-18-at-09-02-pm-001.png)![Screen Shot 05-27-18 at 09.03 PM 002](screenshots/screen-shot-05-27-18-at-09-03-pm-002.png)![Screen Shot 05-27-18 at 09.03 PM](screenshots/screen-shot-05-27-18-at-09-03-pm.png)

![picture.png](screenshots/picture.png)

* * *

## [Buffer](https://buffer.com/) to schedule and share all this content

You must link socials account, write a post, then scheduling it:

1.  Configure Buffer
    1.  create Buffer account at [https://buffer.com/app/](https://buffer.com/app/)
    2.  authorize 1-3 social accounts (Twitter, Facebook, LinkedIn)
2.  Edit a post
    1.  Click on ‘What do you want to share?’
    2.  write a title, description, link, tags
    3.  add image
3.  Schedule social network
    1.  Click ‘Customize for each network’
    2.  Click ‘Add to queue’
4.  …wait tomorrow for post, or click ‘share now’

![Screen Shot 05-27-18 at 10.38 PM](screenshots/screen-shot-05-27-18-at-10-38-pm.png)

![Screen Shot 05-27-18 at 10.40 PM](screenshots/screen-shot-05-27-18-at-10-40-pm.png)

![Screen Shot 05-27-18 at 10.41 PM](screenshots/screen-shot-05-27-18-at-10-41-pm.png)![Screen Shot 05-27-18 at 10.42 PM](screenshots/screen-shot-05-27-18-at-10-42-pm.png)![Screen Shot 05-27-18 at 10.43 PM](screenshots/screen-shot-05-27-18-at-10-43-pm.png)

![Screen Shot 05-27-18 at 10.43 PM 001](screenshots/screen-shot-05-27-18-at-10-43-pm-001.png)

![Screen Shot 05-27-18 at 10.44 PM.PNG](screenshots/screen-shot-05-27-18-at-10-44-pm.png)

* * *

## Conclusion

You can easily capture and share your work for pretty much to nothing (screenshots, videos, presentations to Twitter of Facebook).